import Flutter
import UIKit

public class ProhibitScreenPlugin: NSObject, FlutterPlugin {
    
    private var screenPrevent = UITextField()
    private var window: UIWindow? = nil

    public static func register(with registrar: FlutterPluginRegistrar) {
      let channel = FlutterMethodChannel(name: "prohibit_screen", binaryMessenger: registrar.messenger())
      let instance = ProhibitScreenPlugin()
      registrar.addMethodCallDelegate(instance, channel: channel)
      registrar.addApplicationDelegate(instance)
    }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
       if (call.method == "screenshotOFF") {
            screenshotOFF()
            result(true)
        } else if (call.method == "screenshotON" ){
            screenshotON()
            result(true)
        }
    }
    
    public func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [AnyHashable : Any] = [:]) -> Bool {
        window = UIApplication.shared.delegate?.window as? UIWindow
        if let mainWindow = window {
            if (!mainWindow.subviews.contains(screenPrevent)) {
                mainWindow.addSubview(screenPrevent)
                screenPrevent.centerYAnchor.constraint(equalTo: mainWindow.centerYAnchor).isActive = true
                screenPrevent.centerXAnchor.constraint(equalTo: mainWindow.centerXAnchor).isActive = true
                mainWindow.layer.superlayer?.addSublayer(screenPrevent.layer)
                screenPrevent.layer.sublayers?.first?.addSublayer(mainWindow.layer)
            }
        }
        return true
    }
    
    private func screenshotOFF() {
        screenPrevent.isSecureTextEntry = true
    }
    
    private func screenshotON() {
        screenPrevent.isSecureTextEntry = false
    }
}
