import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'prohibit_screen_platform_interface.dart';

/// An implementation of [ProhibitScreenPlatform] that uses method channels.
class MethodChannelProhibitScreen extends ProhibitScreenPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('prohibit_screen');
  
  @override
  Future<bool?> screenshotOFF() async {
    final rec = await methodChannel.invokeMethod<bool>('screenshotOFF');
    return rec;
  }

  @override
  Future<bool?> screenshotON() async {
    final rec = await methodChannel.invokeMethod<bool>('screenshotON');
    return rec;
  }
}
