import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'prohibit_screen_method_channel.dart';

abstract class ProhibitScreenPlatform extends PlatformInterface {
  /// Constructs a ProhibitScreenPlatform.
  ProhibitScreenPlatform() : super(token: _token);

  static final Object _token = Object();

  static ProhibitScreenPlatform _instance = MethodChannelProhibitScreen();

  /// The default instance of [ProhibitScreenPlatform] to use.
  ///
  /// Defaults to [MethodChannelProhibitScreen].
  static ProhibitScreenPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [ProhibitScreenPlatform] when
  /// they register themselves.
  static set instance(ProhibitScreenPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }
  
  Future<bool?> screenshotOFF() async {
    throw UnimplementedError('screenshotOFF() has not been implemented.');
  }

  Future<bool?> screenshotON() async {
    throw UnimplementedError('screenshotON() has not been implemented.');
  }
}
